{***************************************************************************}
{*                                                                         *}
{*                       p  MSG 䠩.                    *}
{*                                                                         *}
{*      Copyright (c) 1996 by Alexander S. Tokareff, 2:5077/27@Fidonet     *}
{*                                                                         *}
{***************************************************************************}
Unit Msgs;
Interface
Uses Objects, Defs;
Type
 PMsgParent = ^TMsgParent;
 TMsgParent = object(TObject)
  procedure Store(var S : TStream); virtual;
 end;

 PNetMsg = ^TNetMsg;
 TNetMsg = object(TMsgParent)
  From, Too : String36;
  Subject : String72;
  Date : DateTime;
  TimesRead, DestNode, OrigNode, Cost, OrigNet, DestNet, ReplyTo, Attr,
  NextReply : word;
  TextMsg : PTextBuffer;

  constructor Init(var S : TStream);
  constructor Create(AFrom, AToo : String36; ASubject : String72;
                     ADate : DateTime; ATimesRead, ADestNode, AOrigNode,
                     ACost, AOrigNet, ADestNet, AReplyTo, AAttr,
                     ANextReply : word; ATextMsg : PTextBuffer;
                     ATextLen : longint);
  destructor Done; virtual;

  function GetFrom : String36;
  function GetToo : String36;
  function GetSubject : String72;
  function GetDate : DateTime;
  function GetTimesRead : word;
  function GetDestNode : word;
  function GetOrigNode : word;
  function GetCost : word;
  function GetOrigNet : word;
  function GetDestNet : word;
  function GetReplyTo : word;
  function GetAttr : word;
  function GetNextReply : word;
  function GetTextMsg : PTextBuffer;
  function GetTextLen : longint;

  procedure Store(var S : TStream); virtual;
 private
  TextLen : longint;
 end;
Implementation

 procedure TMsgParent.Store;
 begin
 end;

 constructor TNetMsg.Init;
 begin
  inherited Init;
  with S do
  begin
   Seek(0);
   From[0] := #36;
   Read(From[1], 36);
   Too[0] := #36;
   Read(Too[1], 36);
   Subject[0] := #72;
   Read(Subject[1], 72);
   Date[0] := #20;
   Read(Date[1], 32);
   Seek(184);
   Read(ReplyTo, 6);
   TextLen := GetSize - GetPos;
   GetMem(TextMsg, TextLen);
   Read(TextMsg^, TextLen);
  end;
 end;

 constructor TNetMsg.Create;
 begin
  inherited Init;
  From := AFrom; Too := AToo; Subject := ASubject; Date := ADate;
  TimesRead := ATimesRead; DestNode := ADestNode; OrigNode := AOrigNode;
  Cost := ACost; OrigNet := AOrigNet; DestNet := ADestNet;
  ReplyTo := AReplyTo; Attr := AAttr; NextReply := ANextReply;
  TextMsg := ATextMsg;
  TextLen := ATextLen;
 end;

 destructor TNetMsg.Done;
 begin
  if TextMsg <> nil then FreeMem(TextMsg, TextLen);
  inherited Done;
 end;

 function TNetMsg.GetFrom;
 begin
  GetFrom := From;
 end;

 function TNetMsg.GetToo;
 begin
  GetToo := Too;
 end;

 function TNetMsg.GetSubject;
 begin
  GetSubject := Subject;
 end;

 function TNetMsg.GetDate;
 begin
  GetDate := Date;
 end;

 function TNetMsg.GetTimesRead;
 begin
  GetTimesRead := TimesRead;
 end;

 function TNetMsg.GetDestNode;
 begin
  GetDestNode := DestNode;
 end;

 function TNetMsg.GetOrigNode;
 begin
  GetOrigNode := OrigNode;
 end;

 function TNetMsg.GetCost;
 begin
  GetCost := Cost;
 end;

 function TNetMsg.GetOrigNet;
 begin
  GetOrigNet := OrigNet;
 end;

 function TNetMsg.GetDestNet;
 begin
  GetDestNet := DestNet;
 end;

 function TNetMsg.GetReplyTo;
 begin
  GetReplyTo := ReplyTo;
 end;

 function TNetMsg.GetAttr;
 begin
  GetAttr := Attr;
 end;

 function TNetMsg.GetNextReply;
 begin
  GetNextReply := NextReply;
 end;

 function TNetMsg.GetTextMsg;
 begin
  GetTextMsg := TextMsg;
 end;

 function TNetMsg.GetTextLen;
 begin
  GetTextLen := TextLen;
 end;

 procedure TNetMsg.Store;
 begin
  with S do
  begin
   Seek(0);
   Truncate;
   Write(From[1], 36);
   Write(Too[1], 36);
   Write(Subject[1], 72);
   Write(Date[1], 32);
   Write(Fill8, 8);
   Write(ReplyTo, 6);
   Write(TextMsg^, TextLen);
  end;
 end;
End.


